#include "RTOS.H"
#include "../sender.h"
#include "../sender_ext.h"
#include "../receiver.h"
#include "../receiver_ext.h"


#if WIN32
#include <stdio.h>
#include <windows.h>
#include <sys/timeb.h>
#include <time.h>
HANDLE hFile; 
#endif

// state machine data
SENDER_INSTANCEDATA_T sndInst = SENDER_INSTANCEDATA_INIT;
RECEIVER_INSTANCEDATA_T recInst = RECEIVER_INSTANCEDATA_INIT;

OS_STACKPTR int Stack0[128];
OS_TASK receiverTcb;
OS_TIMER sndTimer;

OS_MAILBOX MBEv; 
char MBEvBuffer[6];

void Trace(unsigned char* msg){

#if WIN32
	static int i=0;
	DWORD wmWritten;
	unsigned char tmpBuf[40];
	unsigned char timeBuf[40];
	time_t ltime;

	//OS_Use(&SemaTrace);
	time( &ltime );
	ctime_s( timeBuf, 26, &ltime );
	WriteFile(hFile,timeBuf,(DWORD)(strlen(timeBuf)),&wmWritten,NULL); 
	sprintf(tmpBuf,"%s\n\r",msg);
	WriteFile(hFile,tmpBuf,(DWORD)(strlen(tmpBuf)),&wmWritten,NULL); 
	//OS_Unuse(&SemaTrace);
#endif
}

// receiver task
void Task0(void) {
	while(1){
		OS_Delay(50);
		receiver(&recInst);
	}
}

void TimerHandler(void) {
	sender(&sndInst);
}




void embos_main(void) {
  int i=0;
	
  OS_IncDI();                      /* Initially disable interrupts  */
  OS_InitKern();                   /* initialize OS                 */
  OS_InitHW();                     /* initialize Hardware for OS    */

#if WIN32
  hFile = CreateFile("C:\\trace.txt",GENERIC_READ|GENERIC_WRITE, 
		FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
#endif

  OS_CREATETASK(&receiverTcb, "REC", Task0, 100, Stack0);

   /* Create mailbox, functioning as type ahead buffer */
  OS_CREATEMB(&MBEv, 1, sizeof(MBEvBuffer), &MBEvBuffer);

	/* Create and start a timer */ 
  OS_CREATETIMER(&sndTimer, TimerHandler, 10000);

  OS_Start();                      /* Start multitasking            */
}

